import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkAdmin, ThinkAdminParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkAdmin(params: ThinkAdminParam) {
  const res = await request.get<ApiResult<PageResult<ThinkAdmin>>>(
    THINK_API_URL + '/think/think-admin/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkAdmin(params?: ThinkAdminParam) {
  const res = await request.get<ApiResult<ThinkAdmin[]>>(
    THINK_API_URL + '/think/think-admin',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkAdmin(data: ThinkAdmin) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-admin',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkAdmin(data: ThinkAdmin) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-admin',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkAdmin(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-admin/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkAdmin(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-admin/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkAdmin(id: number) {
  const res = await request.get<ApiResult<ThinkAdmin>>(
    THINK_API_URL + '/think/think-admin/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
